设为首页收藏本站

晓东CAD家园-论坛

 找回密码
 立即注册

QQ登录

只需一步,快速开始

扫一扫,访问微社区

查看: 45|回复: 0

[其他] 外部DWG创建 AcDbXRefGraph

[复制链接]

已领礼包: 40个

财富等级: 招财进宝

发表于 2021-1-12 01:59:43 | 显示全部楼层 |阅读模式

马上注册,结交更多好友,享用更多功能,让你轻松玩转社区。

您需要 登录 才可以下载或查看,没有帐号?立即注册

x

问题:

In ObjectARX there only seems to be one function to create an AcDbXRefGraph
of a drawing, this function is called acedGetCurDwgXRefGraph.

The problem is that this only works on the current drawing!! How can I create
an AcDbXRefGraph of an external drawing (AcDbDatabase) that I have read in?


解答:

Here is a function to do the trick.


  1. // ObjectARX defined commands


  2. #include "StdAfx.h"
  3. #include "StdArx.h"


  4. // function to fill in an AcDbXrefGraph with a completed graph of the current drawing's xrefs.
  5. // Returns Acad::eOk if successful.
  6. Acad::ErrorStatus GetXrefGraph (AcDbDatabase *dwgDb, AcDbXrefGraph& graph);


  7. // This is command 'TEST'
  8. void asdktest()
  9. {
  10. // lock the document
  11. AcAxDocLock docLock;
  12. // now read in an external drawing
  13. AcDbDatabase *db = new AcDbDatabase (false);
  14. // if we created the db ok
  15. if (db != NULL)
  16. {
  17.   Acad::ErrorStatus es;
  18.   // try and read in the drawing
  19.   es = db->readDwgFile ("c:\\temp\\114-AB1B2.dwg");
  20.   // if ok
  21.   if (es == Acad::eOk)
  22.   {
  23.    AcDbXrefGraph graph;
  24.    // try out our new function
  25.    GetXrefGraph (db, graph);
  26.    // a little test to see if it worked
  27.    acutPrintf ("\nNumber of nodes = %d", graph.numNodes ());
  28.   }
  29.   delete db;
  30. }
  31. }


论坛插件加载方法
发帖求助前要善用【论坛搜索】功能,那里可能会有你要找的答案;
如果你在论坛求助问题,并且已经从坛友或者管理的回复中解决了问题,请把帖子标题加上【已解决】;
如何回报帮助你解决问题的坛友,一个好办法就是给对方加【D豆】,加分不会扣除自己的积分,做一个热心并受欢迎的人!
您需要登录后才可以回帖 登录 | 立即注册

本版积分规则

QQ|申请友链|小黑屋|手机版|Archiver|辽公网安备|晓东CAD家园 ( 辽ICP备15016793号 )  

GMT+8, 2021-1-22 07:59 , Processed in 0.049653 second(s), 12 queries , Gzip On, WinCache On.

Powered by Discuz! X3.4

Copyright © 2001-2020, Tencent Cloud.

快速回复 返回顶部 返回列表